/* calcSegShape.cc */
/* $Lastupdate: Sat Jan 31 16:45:57 1998 $ */

/*

[ץ̾]

calcSegShape.cc -- plain format V.1,2 б --

[򤹤ץफ]

calcSegShape.cc ϡplain format V.1,2 ƲƻʬĹ
ʿѸۤ׻ץǤ

[Ȥ]

(1) ʤǵư :

% calcSegShape
# input file (plain format V.1 or 2) : sample.pf2.data
# output file (segment shape format V.1) : sample.shape.data
# default value of gradient : 0.001

(2) Ĥǵư :

% calcSegShape shape.pf2.data shape.shape.data 0.001

  o "shape.pf2.data" ϡplain format V.2 ǡåȤǤ

  o "shape.shape.data" ϡƲƻʬĹʿѸۤ
     ϥեǤ

  o "0.001" ϥǥեȤθۤǤ

[ϥեΥեޥå]

plain format V.1  V.2

[ϥեΥեޥå]

segment shape format V.1

segment shape format V.1  [Data] ϼΤ褦ʥեޥåȤ
ʤäƤޤ

(a) (b) (c) (d) (e)  (f)      (g)
 1   1   18  19  -22  2072.16  0.001
 1   1   13  17  -19  2627.71  0.001
 1   1   12  18  -17  3474.9   0.0203034
 1   1   20  24  -17  4727.54  0.0846635
 1   1   21  25  -17  8662.44  0.0140772
 1   1   47  62  -25  5276.95  0.00621102
 1   1   48  63  -25  5117     0.0178264

(a) ޳ֹ(x )
(b) ޳ֹ(y )
(c) ƻʬֹ
(d) üֹ
(e) üֹ
(f) ƻʬĹ
(g) ƻʬ

(d),(e) üֹϡξή¦üɽξϲή¦
üɽƤޤ

[ѥ]

% make

[]

  o ƻʬξüɸͤͿƤϡξü
    ɸ⺹򤽤βƻʬĹǽƸۤȤޤ

  o ƻʬβƻɸͤ٤Ʒ¬ξϡβƻ
    ʬθۤ׻Ǥޤ󡣤ΤȤϡ桼ꤷǥ
	Ȥθͤ򤽤βƻʬθۤȤޤ

  o üɸͤ¬Ǥ⡢ƻʬɸͤͿƤ
    ĤǤ⤢ϡü˺ǤᤤǥեȤθۤ
    üɸޤޤΤȡüɸ⺹ƻʬĹ
	ǽƸۤȤޤ

  o ƻʬĹ 0 ξ硢ۤϥǥեͤȤޤ

*/

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <iomanip.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khslist.h"
#include "khslist.cc"
#include "khstr.h"
#include "khdfstream.h"
#include "nopath.h"				// for nopath

// ȤʤɡХѿ

double GRADIENT; // ǥեȤθ

double MACEPS;	 // ׻ץ

double Maceps // float η׻ץ֤
(
	void
)
{
	double e, w;
	e = 1.0; w = 1.0 + e;

	while (w > 1.0)
	{
// 		printf("% -14g % -14g % -14g\n", e, w, w-1);
		e /= 2.0; w = 1.0 + e;
	}

	return(e * 2.0);
}

class Point
{
  protected:

	int gx, gy;					// ޳ֹ
	long pnum;					// ֹ
	long snum;					// ƻʬֹ
	int pos;					// ΰ־
	double x, y, z;				// ɸ
	double w;					// ƻ

  public:

	void Init(int wgx, int wgy, long wpnum, long wsnum, int wpos,
			  double wx, double wy, double wz, double ww)
	{ gx = wgx; gy = wgy; pnum = wpnum; snum = wsnum; pos = wpos;
	  x = wx; y = wy; z = wz; w = ww; }

	Point(void) {}

	Point(int wgx, int wgy, long wpnum, long wsnum, int wpos,
		  double wx, double wy, double wz, double ww)
	{ Init(wgx, wgy, wpnum, wsnum, wpos, wx, wy, wz, ww); }

	long Gx(void) { return gx; }
	long Gy(void) { return gy; }
	long Pnum(void) { return pnum; }
	long Snum(void) { return snum; }
	int Pos(void) { return pos; }
	double X(void) { return x; }
	double Y(void) { return y; }
	double Z(void) { return z; }
	double W(void) { return w; }

	void Z(double wz) { z = wz; }
};

template class KhSListDynamic<Point>;

class Segment
{
	double len;					// Ĺ
    double grd;					// 

	int numz;					// ɸͤͿƤο

	KhSListDynamic<Point> plist;
	int numberOfPoints;			// plist.GetCount()
	Point* pArray;				// plist ή¤ľ

  public:

	Segment(void) { pArray = NULL; }
	Segment(const Segment& s);
	void operator = (const Segment& s);

	~Segment(void) { delete [] pArray; }

	// ѱ黻Ҥκ
	friend ofstream& operator<<(ofstream& os, const Segment& seg);
	friend ostream& operator<<(ostream& os, const Segment& seg);

	// ޳ֹ֤
	int Gx(void) const { return pArray[0].Gx(); }
	int Gy(void) const { return pArray[0].Gy(); }

	// ƻʬֹ֤
	long Snum(void) const { return pArray[0].Snum(); }

	// üüֹ֤
	long LowerEnd(void) const { return pArray[0].Pnum(); }

	// üüֹ֤
	long UpperEnd(void) const { return pArray[numberOfPoints-1].Pnum(); }

	// ƻʬĹ֤
	double Length(void) const { return len; }

	// ƻʬ֤ۤ
	double Gradient(void) const { return grd; }

	// numz ꤹ
	void Numz(int n) { numz = n; }

	// plist  pArray ¤ľ
	void PlistToParray(void);

	// p  plist ˥ڥɤ
	void AddToPlist(Point p) { plist.Append(p); }

	// Ĺ׻
	void CalcLength(void);

	// ۤ׻
	void CalcGradient(void);

};

Segment::Segment(const Segment& s)
{
	len = s.len;
	grd = s.grd;
	numz = s.numz;

	plist = s.plist;
	numberOfPoints = s.numberOfPoints;
	delete [] pArray; 
	pArray = new Point[numberOfPoints];
	for (int i = 0; i < numberOfPoints; i++)
		pArray[i] = s.pArray[i];
}

void Segment::operator = (const Segment& s)
{
	len = s.len;
	grd = s.grd;
	numz = s.numz;

	plist = s.plist;
	numberOfPoints = s.numberOfPoints;
	delete [] pArray; 
	pArray = new Point[numberOfPoints];
	for (int i = 0; i < numberOfPoints; i++)
		pArray[i] = s.pArray[i];
}

void Segment::PlistToParray		// plist  ή¦ 
								// pArray ¤ľ
(
	void
)
{
	//  Segment ˴ޤޤƤƻο
	numberOfPoints = plist.GetCount();

	pArray = new Point[numberOfPoints];

	plist.ToHead();
	Point wp = plist.Get();

	if (wp.Pnum() < 0)			// ή¦ǡäƤ
	{
		for (KhBoolean r = plist.ToHead(), i = 0; r == YES; 
			 r = plist.ToNext(), i++)
		{
			pArray[i] = plist.Get();
		}
	}
	else
	{
		for (KhBoolean r = plist.ToHead(), i = numberOfPoints-1; 
			 r == YES; r = plist.ToNext(), i--)
		{
			pArray[i] = plist.Get();
		}
	}

	// plist õ
	plist.Erase();
}

void Segment::CalcLength(void)
{
	len = 0.0;
	for (int i = 1; i < numberOfPoints; i++)
	{
		double cx, cy, px, py;
		cx = pArray[i].X(); cy = pArray[i].Y();
		px = pArray[i-1].X(); py = pArray[i-1].Y();
		len += sqrt((cx-px)*(cx-px) + (cy-py)*(cy-py));
	}
}

void Segment::CalcGradient(void)
{
	// ɸͤͿƤĤʤ
	// ۤϥǥեͤȤ
	if (numz == 0)
	{
		grd = GRADIENT;
		return;
	}

	// ƻʬĹ 0 ξ硢ۤϥǥեͤȤ
//	if (len == 0.0)
	if (len <= MACEPS)
	{
		grd = GRADIENT;
		return;
	}

	// ɸͤͿƤ¸ߤ

	// ή¦üɸͤͿƤʤ
//	if (pArray[0].Z() <= 0.0)
	if (pArray[0].Z() <= MACEPS)
	{
		double wz; double wlen = 0.0;
		double cx, cy, px, py;
		px = pArray[0].X(); py = pArray[0].Y();

		for (int i = 1; i < numberOfPoints; i++)
		{
			cx = pArray[i].X(); cy = pArray[i].Y();
			wlen += sqrt((cx-px)*(cx-px) + (cy-py)*(cy-py));
			wz = pArray[i].Z();
//			if (wz > 0.0) break;
			if (wz > MACEPS) break;
			px = cx; py = cy;
		}

		wz = wz - GRADIENT * wlen;
		pArray[0].Z(wz);
	}

	// ή¦üɸͤͿƤʤ
//	if (pArray[numberOfPoints-1].Z() <= 0.0)
	if (pArray[numberOfPoints-1].Z() <= MACEPS)
	{
		double wz; double wlen = 0.0;
		double cx, cy, px, py;
		px = pArray[numberOfPoints-1].X();
		py = pArray[numberOfPoints-1].Y();

		for (int i = numberOfPoints-2; i >= 0; i--)
		{
			cx = pArray[i].X(); cy = pArray[i].Y();
			wlen += sqrt((cx-px)*(cx-px) + (cy-py)*(cy-py));
			wz = pArray[i].Z();
//			if (wz > 0.0) break;
			if (wz > MACEPS) break;
			px = cx; py = cy;
		}

		wz = wz + GRADIENT * wlen;
		pArray[numberOfPoints-1].Z(wz);
	}

	// ξüɸͤۤ׻
	grd = (pArray[numberOfPoints-1].Z() - pArray[0].Z()) / len;
}

ofstream& operator<<			// Segment ǡν
(
	ofstream& os,				// ϥȥ꡼
 	const Segment& seg			// Segment ǡ
)
{
	os << seg.Gx() << " " << seg.Gy() << " "
	   << seg.Snum() << " " 
	   << seg.UpperEnd() << " " << seg.LowerEnd() << " " 
	   << seg.Length() << " " << seg.Gradient() ;

	return os;
}

ostream& operator<<				// Segment ǡν
(
	ostream& os,				// ϥȥ꡼
 	const Segment& seg			// Segment ǡ
)
{
	os << seg.Gx() << " " << seg.Gy() << " "
	   << seg.Snum() << " " 
	   << seg.UpperEnd() << " " << seg.LowerEnd() << " " 
	   << seg.Length() << " " << seg.Gradient() ;

	return os;
}


void usage(const KhString& command)
{
  cerr
  << "\n" << command << " calculates length and gradient of stream segments from PF data.\n"
  << "usage: " << command << " [options] [iFile] [oFile] [grd]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  iFile : plain format V.1 or 2 file\n"
  << "  oFile : segment shape format V.1\n"
  << "  grd   : default value of gradient\n"
  << "  If \"iFile\", \"oFile\" and \"grd\" are given in the command line, \n"
  << "  the input data are read in from the file.\n"
  << "  Otherwise, the input data are read in from STDIN\n"
  << "  with giving prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
	cerr << "\nThis is calcSegShape ver. 1.1\n"
		 << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" << endl;
}

int main(int argc, char** argv)
{
	KhString command = nopath(argv[0]);

  	// optstring ǡץȤƵʸꤷޤ
	char *optstring = "hv";

	int c;
	while((c = getopt(argc, argv, optstring)) != EOF)
	{
    	// getopt ϲϤץʸ֤ޤ
		switch (c) {
		  case 'v':
			version();
			break;
		  case 'h':
			// ץʸ h ֤Ƥν
			// fall through
		  default:
			usage(command);
		}
	}

	// argc ˤ, ޥ̾ȰθĿޤĤʤ
	// Ȥargc ˤ 1 ޤ

	if (argc != 1 && argc != 4)
	{
		//  command ǤϡθĿ3Ĥޤ0ĤǤ
		usage(command);
	}

	// ϥե̾
	char in[256], out[256];
	if (argc == 1) {
		cout << "# input file (plain format V.1,2) : ";
		cin >> in;
		cout << "# output file (segment shape format V.1) : ";
		cin >> out;
		cout << "# default value of gradient : ";
		cin >> GRADIENT;
	}
	else {
		istrstream istri(argv[1]);
		istri >> in;
		istrstream istro(argv[2]);
		istro >> out;
		istrstream istrg(argv[3]);
		istrg >> GRADIENT;
	}

	// ׻ץ׻
	MACEPS = Maceps();

	// ϥե
	KhDfstream iFile(in);
	// ϥե
	ofstream oFile(out);

	KhString buf;
	getline(iFile, buf);
	if (buf == "[Comment]")		// V.2
	{
		oFile << buf << endl;
		oFile << "This data was generated from " << in 
			  << " by " << command << "." << endl;
		while (getline(iFile, buf) && buf != "[Data Format Name]")
			oFile << buf << endl;
	}
	else if (buf == "[Data Format Name]") // V.1
	{
		oFile << "[Comment]" << endl;
		oFile << "This data was generated from " << in 
			  << " by " << command << endl;
	}
	else if (buf != "[Data Format Name]") // V.1 Ǥ 2 Ǥʤ
	{
		kherror();
		cerr << "iFile must be plain format V.1 or 2" << endl;
		exit(1);
	}

	oFile << buf << endl;		// [Data Format Name]
	getline(iFile, buf);
	oFile << "segment shape format V.1" << endl;

	// [Coordinate System]  [Vertices of the Map] ޤǤ򥳥ԡ
	while (getline(iFile, buf) && buf != "[Number of End Points]") 
		oFile << buf << endl;

	// [Number of River Segments] ޤǶɤߡ
	while (getline(iFile, buf) && buf != "[Number of River Segments]") ;

	oFile << buf << endl;		// "[Number of River Segments]"

	// [Number of River Segments] ɤ߹
	getline(iFile, buf);
	int numSegment;
	istrstream strmseg(buf);
	strmseg >> numSegment;
	Segment* seg = new Segment[numSegment];
	oFile << buf << endl;		// [Number of River Segments]

	// [Data] ޤǶɤ
	while (getline(iFile, buf) && buf != "[Data]") ;

	// [Data] ɤ߹

	int gx, gy;					// åɥܥåֹ
	int pnum;					// üֹ
	int snum;					// ƻʬֹ
	int pos;					// ־
	double x, y, z;				// ֺɸ
	double w;					// ƻ

	KhBoolean inside = NO; // YES : ƻʬ
						   // NO  : ƻʬФ

	int numz;					// ɸͤͿƤο

	int segCount = -1;

	while (getline(iFile, buf))
	{
		// ʸ󥹥ȥ꡼˥ǡɤ߹
		istrstream iss(buf, 256);
		iss >> gx >> gy >> pnum >> snum >> pos
			>> x >> y >> z >> w;

		// ʲƻʬä
		if (inside == NO && pos >= 0)
		{
			inside = YES;
			segCount++;
			numz = 0;
		}
		// Ĥβƻʬä
		else if (inside == YES && pos >= 0)
		{
			inside = NO;
			if (z > 0.0) numz++;
			seg[segCount].Numz(numz);
		}

//		if (z > 0.0) numz++;
		if (z > MACEPS) numz++;

		// ƻΥǡꥹȤ˼Ͽ
		Point p(gx, gy, pnum, snum, pos, x, y, z, w);
		seg[segCount].AddToPlist(p);
	}

	iFile.close();

	// plist  pArray ѴĹۤ׻
	for (int i = 0; i < numSegment; i++)
	{
		seg[i].PlistToParray();		// plist  pArray Ѵ
		seg[i].CalcLength();		// ƻʬĹ׻
		seg[i].CalcGradient();		// ƻʬۤ׻
	}

	// 

	oFile << "[Data]" << endl;
	for (int i = 0; i < numSegment; i++)
	{
		oFile << seg[i] << endl;
	}

	delete [] seg;

	return 0;
}
